//
//  PayKunHelper.swift
//  PayKun_Demo
//
//  Created by Akash Patel on 14/10/21.
//

import PayKun
import Foundation

class PayKunHelper : NSObject {
    
    static let shared = PayKunHelper()
    var objPaykun: PaykunCheckout?
    var paymentCompletion : ((_ errorMessage : String?, _ transactionID: String?, _ fullResponse : [String : Any]?)->Void)?
    
    func initiatePaymentWithPayKun(DeviceAPIKey: String, MerchantID: String, isLiveMode: Bool, name: String, email: String, mobile: String, productInfo: String, amount: String, currency: String, controller : UIViewController, completion : @escaping (_ errorMessage : String?, _ transactionID: String?, _ fullResponse : [String : Any]?)->Void) {
        
        paymentCompletion = completion
        objPaykun = PaykunCheckout.init(key: DeviceAPIKey, merchantId: MerchantID, isLive: isLiveMode, andDelegate: self)
        
        var orderId = "\(1 + arc4random_uniform(9))"
        for _ in 0..<22 {
            orderId = orderId + ("\(arc4random_uniform(10))")
        }
        
        objPaykun?.checkout(withCustomerName: name, customerEmail: email, customerMobile: mobile, productName: productInfo, orderNo: orderId, amount: amount, currency: currency, viewController: controller)
    }
}

extension PayKunHelper : PaykunCheckoutDelegate {
    
    //Success
    func onPaymentSucceed(_ responce: [AnyHashable : Any]) {
        print("responce: \(responce)")
        print("Payment Success with Transaction ID: \(responce["req_id"] as? String ?? "NA")")
        if let transactionID = responce["req_id"] as? String {
            objPaykun?.getTransactionByPaymentId(transactionID, block: { responseDetails in
                print("responce INSIDE PLUGIN: \(responseDetails)")
                if let data = responseDetails["data"] as? [String : Any], let transactionDetails = data["transaction"] as? [String : Any] {
                    self.paymentCompletion?(nil, transactionID, transactionDetails)
                } else {
                    self.paymentCompletion?(nil, transactionID, nil)
                }
            })
        }
    }

    //Fail
    func onPaymentFailed(_ responce: [AnyHashable : Any]) {
        print("responce: \(responce)")
        objPaykun?.getTransactionByPaymentId(responce["req_id"] as? String ?? "", block: { responceDetails in
            print("responce INSIDE PLUGIN: \(responceDetails)")
            if let errorMessage = responceDetails["message"] as? String {
                self.paymentCompletion?(errorMessage, nil, nil)
            } else {
                self.paymentCompletion?("Payment failed with unknown reason. Please try again later", nil, nil)
            }
        })
    }
}
