import Flutter
import UIKit

public class SwiftSpectusPaykunPlugin: NSObject, FlutterPlugin {
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "spectus_paykun", binaryMessenger: registrar.messenger())
    let instance = SwiftSpectusPaykunPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
      if call.method == "getPlatformVersion" {
          result("iOS " + UIDevice.current.systemVersion)
      }
      else if call.method == "startPayKunPayment" {
          if let topVC = UIApplication.shared.windows[0].rootViewController {
              
              guard let args = call.arguments else {
                  return
              }
              if let myArgs = args as? [String: Any], let merchantIdVal = myArgs["merchantId"] as? String,let accessTokenVal = myArgs["accessToken"] as? String,let customerNameVal = myArgs["customerName"] as? String,let customerEmailVal = myArgs["customerEmail"] as? String, let customerPhoneVal = myArgs["customerPhone"] as? String, let productNameVal = myArgs["productName"] as? String, let amountVal = myArgs["amount"] as? String, let currencyVal = myArgs["currency"] as? String, let isLiveVal = myArgs["isLive"] as? Bool {
                  PayKunHelper.shared.initiatePaymentWithPayKun(DeviceAPIKey: accessTokenVal, MerchantID: merchantIdVal, isLiveMode: isLiveVal, name: customerNameVal, email: customerEmailVal, mobile: customerPhoneVal, productInfo: productNameVal, amount: amountVal, currency: currencyVal, controller : topVC, completion : { (_ errorMessage, _ transactionID, _ fullResponse) in
                      result(transactionID)
                  })
              }
          }
      }
      else {
          
      }
  }
}
