import 'dart:async';

import 'package:flutter/services.dart';

class SpectusPaykun {
  static const MethodChannel _channel = MethodChannel('spectus_paykun');

  static Future<String?> get platformVersion async {
    final String? version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  static Future<String> startPayKunPayment(
      {String? merchantId,
      String? accessToken,
      String? customerName,
      String? customerEmail,
      String? customerPhone,
      String? productName,
      String? amount,
      String? currency,
      bool? isLive}) async {
    print("Start Paykun in Dart");
    final String transactionID =
        await _channel.invokeMethod('startPayKunPayment', {
      "merchantId": merchantId,
      "accessToken": accessToken,
      "customerName": customerName,
      "customerEmail": customerEmail,
      "customerPhone": customerPhone,
      "productName": productName,
      "amount": amount,
      "currency": currency,
      "isLive": isLive
    });

    print("OUTSIDE DART PLUGIN METHOD CALL");
    if (transactionID == null) {
      return "NA";
    } else {
      return transactionID;
    }
  }
}
